<?php
// +----------------------------------------------------------------------
// | ThinkPHP [ WE CAN DO IT JUST THINK ]
// +----------------------------------------------------------------------
// | Copyright (c) 2006-2016 http://thinkphp.cn All rights reserved.
// +----------------------------------------------------------------------
// | Licensed ( http://www.apache.org/licenses/LICENSE-2.0 )
// +----------------------------------------------------------------------
// | Author: 流年 <liu21st@gmail.com>
// +----------------------------------------------------------------------

// 应用公共文件

function vaptchapost($data)
{
    $data = array(
        "id" => "5dd1294827d451dade2f342d",
        "secretkey" => "1598d0755a534676927e686fc884a0bb",
        "scene" => "2",
        "token" => $data["vaptcha_token"],
        "ip" => $data["ip"],
    );
    $url = "http://0.vaptcha.com/verify";
    $postdata = http_build_query($data);
    $options = array(
        'http' => array(
            'method' => 'POST',
            'header' => 'Content-type:application/x-www-form-urlencoded',
            'content' => $postdata,
            'timeout' => 15 * 60 // 超时时间（单位:s）
        )
    );

    $context = stream_context_create($options);
    $result = json_decode(file_get_contents($url, false, $context),true);
    if(isset($result["success"]) && $result["success"]== 1){
        return true;

    }else{
        return false;
    }

}
function request_by_curl($url, $jsonStr) {
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_POST, 1);
    curl_setopt($ch, CURLOPT_URL, $url);
    curl_setopt($ch, CURLOPT_POSTFIELDS, $jsonStr);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($ch, CURLOPT_HTTPHEADER, array(
            'Content-Type: application/json; charset=utf-8',
            'Content-Length: ' . strlen($jsonStr)
        )
    );
    $response = curl_exec($ch);
    curl_close($ch);
    return $response;
}


/**
 * 对数组排序
 * @param $para 排序前的数组
 * return 排序后的数组
 */
function argsSort($params) {
	ksort($params);
	reset($params);
	return $params;
}

/**
 * 把数组所有元素，按照“参数=参数值”的模式用“&”字符拼接成字符串，并对字符串做urlencode编码
 * @param $params 需要拼接的数组
 * return 拼接完成以后的字符串
 */
function createLinkstring($params) {
	$args  = "";
	foreach ($params as $key=>$val) {
		$args.=$key."=".$val."&";
	}
	//去掉最后一个&字符
	$args = substr($args, 0, -1);
	
	return $args;
}

/**
 * 签名字符串
 * @param $prestr 需要签名的字符串
 * @param $key 私钥
 * return 签名结果
 */
function md5Sign($prestr, $key) {
	$prestr = $prestr . $key;
	return md5($prestr);
}
function pay_sign($key_id, $array){
    $data = md5(sprintf("%.2f", $array['amount']) . $array['out_trade_no']);
	$key[] ="";
	$box[] ="";
	$pwd_length = strlen($key_id);
	$data_length = strlen($data);
	for ($i = 0; $i < 256; $i++)
	{
		$key[$i] = ord($key_id[$i % $pwd_length]);
		$box[$i] = $i;
	}
	for ($j = $i = 0; $i < 256; $i++)
	{
		$j = ($j + $box[$i] + $key[$i]) % 256;
		$tmp = $box[$i];
		$box[$i] = $box[$j];
		$box[$j] = $tmp;
	}
	$cipher = "";
	for ($a = $j = $i = 0; $i < $data_length; $i++)
	{
		$a = ($a + 1) % 256;
		$j = ($j + $box[$a]) % 256;
		
		$tmp = $box[$a];
		$box[$a] = $box[$j];
		$box[$j] = $tmp;
		
		$k = $box[(($box[$a] + $box[$j]) % 256)];
		$cipher .= chr(ord($data[$i]) ^ $k);
	}
	return md5($cipher);
}

function pay_userkey(){
    return  "商户key";
}

function pay_customerid(){
    return  "商户id";
}

function pay_account_name(){
    return  "wchunh";
}


function pay_k($id,$Test = false){
    $pay = [
        '1' =>
             array(
                 'id' => 1,
                 'nMoney' => "10",
                 'Money' => "",
                 'szDesc' => "【点券1000】",
				 'goods'=>"600001354,1",
				 'jiancheng'=>"【点券1000】"
             ),
         '2' =>
             array(
                 'id' => 2,
                 'nMoney' => "30",
                 'Money' => "",
                 'szDesc' => "【点券3000】",
				 'goods'=>"600001354,3",
				 'jiancheng'=>"【点券3000】"
             ),
        '3' =>
             array(
                 'id' => 3,
                 'nMoney' => "50",
                 'Money' => "",
                 'szDesc' => "【点券5000】",
				 'goods'=>"600000354,1",
				 'jiancheng'=>"【点券5000】"
             ),
         '4' =>
             array(
                 'id' => 4,
                 'nMoney' => "100",
                 'Money' => "",
                 'szDesc' => "【点券10000】",
    			 'goods'=>"600000354,2",
    			 'jiancheng'=>"【点券10000】"
             ),
         '5' =>
             array(
                 'id' => 5,
                 'nMoney' => "200",
                 'Money' => "",
                 'szDesc' => "【点券20000】",
				 'goods'=>"600000354,4",
				 'jiancheng'=>"【点券20000】"
             ),
         '6' =>
             array(
                 'id' => 6,
                 'nMoney' => "500",
                 'Money' => "",
                 'szDesc' => "【点券50000】",
				 'goods'=>"600000354,10",
				 'jiancheng'=>"【点券50000】"
             ),
         '7' =>
             array(
                 'id' => 7,
                 'nMoney' => "30",
                 'Money' => "",
                 'szDesc' => "【月卡*1】",
				 'goods'=>"230000301,1",
				 'jiancheng'=>"【月卡】"
             ),
        '8' =>
             array(
                 'id' => 8,
                 'nMoney' => "198",
                 'Money' => "",
                 'szDesc' => "【理财卡*1】",
				 'goods'=>"230000304,1",
				 'limitType'=>0,
				 'limit'=>1,
				 'jiancheng'=>"【理财卡-单账号仅可一次购买】"
             ),
         '9' =>
             array(
                 'id' => 9,
                 'nMoney' => "1",
                 'Money' => "",
                 'szDesc' => "【1元礼包*1】",
				 'goods'=>"600000001,5000;300000106,50;200110002,2;200000002,100;330000189,1",
				 'limitType'=>1,
				 'limit'=>1,
				 'jiancheng'=>"【1元礼包】"
             ),
         '10' =>
             array(
                 'id' => 10,
                 'nMoney' => "3",
                 'Money' => "",
                 'szDesc' => "【3元礼包*1】",
				 'goods'=>"600000001,10000;300000106,100;200110002,5;200000002,200;330000190,1",
				 'limitType'=>1,
				 'limit'=>1,
				 'jiancheng'=>"【3元礼包】"
             ),
         '11' =>
             array(
                 'id' => 11,
                 'nMoney' => "6",
                 'Money' => "",
                 'szDesc' => "【6元礼包*1】",
				 'goods'=>"600000001,20000;300000106,200;200110002,10;200000002,400;330000191,1",
				 'limitType'=>1,
				 'limit'=>1,
				 'jiancheng'=>"【6元礼包】"
             )
    ];
    if($Test){
        return $pay;
    }else{
        if(isset($pay[$id])){
            return $pay[$id];
        }else{
            return  $id;
        }
    }
}
function pay_kk($id, $Test = false)
{
    $pay = [
        '1' =>
            array(
                'id' => 1,
                'nMoney' => "1"
            ),
        '2' =>
            array(
                'id' => 2,
                'nMoney' => "50"
            ),
        '3' =>
            array(
                'id' => 3,
                'nMoney' => "100"
            ),
        '4' =>
            array(
                'id' => 4,
                'nMoney' => "200"
            ),
        '5' =>
            array(
                'id' => 5,
                'nMoney' => "500"
            ),
        '6' =>
        array(
            'id' => 6,
            'nMoney' => "1000"
        )
    ];
    if ($Test) {
        return $pay;
    } else {
        if (isset($pay[$id])) {
            return $pay[$id];
        } else {
            return $id;
        }
    }


}

function pay_list($type,$id, $Test = false)
{
    $pay['yueka'] = [
         'yk1' =>
             array(
                 'id' => 'yk1',
                 'nMoney' => "198",
                 'szDesc' => "虎虎生威卡",
				 'day' => 999,
                 'goods' => "600002543,2000;600000002,50000;200040600,2;200000317,2;300000214,2;200000310,2;300000205,1;800001351,1;340000020,5;340000040,5;600000063,800"
             ),
     ];

	if ($Test) {
	    return $pay[$type];
	} else {
		if (isset($pay[$type][$id])) {
			return $pay[$type][$id];
		} else {
			return $id;
		}
	}
}

function youjianjk($type,$id)
{
	$request = \think\Request::instance()->get();
	$Indexdemo = new \app\common\controller\Index();
	$name = $Indexdemo->demo();
	$serverread = $Indexdemo->serverread(true);
	$request["server"] = $serverread["server"];
	$request["role"] = base64_decode($serverread["role"]);
	$request["account"] = $name["account"];
	$Test = pay_list($type,$id);
	$newarr = explode(";", $Test["goods"]);
	$gmdata = ["server" => $request["server"], "role" => "", "cmda" => "itemManage", "cmdb" => "giveItem", "body" => ["player_list" => [], "server_broadcast" => "0", "content" => $Test["szDesc"]]];
	$gmdata["body"]["player_list"] = explode(",", $request["role"]);
	$attach_item = [];
	for ($i = 0; $i < count($newarr); $i++) {
		$newarrd = explode(",", $newarr[$i]);
		if (isset($newarrd[0]) && isset($newarrd[1])) {
			
			$attach_item[] = ["id" => $newarrd[0], "num" => $newarrd[1]];
		}
	}
	$attach_itemdf = array_chunk($attach_item, 4);
	$Gamecmd = new \app\common\controller\Game();
	$data_a = $Gamecmd->regionname($request["server"], "t_player_info", "", "", $request["role"], "", true);
	foreach ($attach_itemdf as $key => $value) {
		$gmdata["body"]["items"] = $attach_itemdf[$key];
		$gmdata["body"]["content"] = $Test["szDesc"];
		\think\Log::log("attach_item " . $request["account"] . " -> " . "自分割发货" . " -> " . sizeof($attach_itemdf[$key]) . " -> " . $request["role"]);
		$gg = $Gamecmd->admingm($gmdata);
		if ($gg == 1) {
			\think\Log::log("attach_item " . $request["account"] . " -> " . "兑换成功  " . $i . " -> " . $request["role"]);
		} else {
			\think\Log::log("attach_item " . $request["account"] . " -> " . " 附赠物品发送失败" . " -> " . $request["role"]);
		}
	}
	
}

function md5_k($data,$datat){
    //print_r($user_data);
    return md5( "2585de18884a161fede7689dcce5a7a3" . json_encode($data) . $datat["code"]. "".$datat["msg"]);
}

function xy_md5($data)
{
    $MD5 = "";
    foreach ($data as $key => $value) {
        $MD5 .= $value;
    }
    return md5("#541" . $MD5 . "88#");
}

function genTree($items, $id = 'id', $pid = 'uid', $son = 'son')
{
    $tree = array(); //格式化的树
    $tmpMap = array(); //临时扁平数据
    foreach ($items as $item) {
        $tmpMap[$item[$id]] = $item;
    }
    foreach ($items as $item) {
        if (isset($tmpMap[$item[$pid]]) && $item[$id] != $item[$pid]) {
            if (!isset($tmpMap[$item[$pid]][$son]))
                $tmpMap[$item[$pid]][$son] = array();
            $tmpMap[$item[$pid]][$son][] = &$tmpMap[$item[$id]];
        } else {
            $tree[] = &$tmpMap[$item[$id]];
        }
    }
    return $tree;
}

function http_curl($url = "", $type = 'get', $arr = '')
{
    $ch = curl_init();

    if ($type == 'get') {
        $url = $url . '?' . http_build_query($arr);
    }

    //2.设置curl的参数
    curl_setopt($ch, CURLOPT_URL, $url);
    //设置我们的url
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    //curl_exec执行成功则返回执行结果
    if ($type == 'post') {
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $arr);
        curl_setopt($ch, CURLOPT_COOKIE, "");
        //将$arr发送给$url
    }
    curl_setopt($ch, CURLOPT_TIMEOUT, 5);
    //if end
    $output = curl_exec($ch);
    if (empty($output)) {
        //echo curl_error($ch);
        //echo "<br>";
       // echo curl_errno($ch);
        //echo "<br>";
        $output = json_encode(array("code" => "1001", "msg" => curl_error($ch)));
    }
    curl_close($ch);
    return $output;
}


function sheli_cc()
{
    //代理IP直接退出
    empty($_SERVER['HTTP_VIA']) or exit('Access Denied');
    //防止快速刷新
    session_start();
    $seconds = '60'; //时间段[秒]
    $refresh = '12'; //刷新次数
    //设置监控变量
    $cur_time = time();
    if (isset($_SESSION['last_time'])) {
        $_SESSION['refresh_times'] += 1;
    } else {
        $_SESSION['refresh_times'] = 1;
        $_SESSION['last_time'] = $cur_time;
    }

    //处理监控结果
    if ($cur_time - $_SESSION['last_time'] < $seconds) {
        if ($_SESSION['refresh_times'] >= $refresh) {
            //跳转至攻击者服务器地址
            //header(sprintf('Location:%s', 'http://127.0.0.1'));
            exit('请求频率太快，稍候' . $seconds . '秒后再访问！');
        }
    } else {
        $_SESSION['refresh_times'] = 0;
        $_SESSION['last_time'] = $cur_time;
    }
}

function run_time($consume)
{

    $str = "";
    $str1 = "";
    $str2 = "";
    $str3 = "";
    if ($consume >= 86400) {
        $str = floor($consume / 86400);
        $consume = $consume % 86400;
    }
    if ($consume >= 3600) {
        $str1 = floor($consume / 3600);
        $consume = $consume % 3600;
    } else {
        unset($zero);

    }
    if ($consume >= 60) {
        $str2 = floor($consume / 60);
        $consume = $consume % 60;
    } else {
        unset($zero);

    }
    if ($consume > 0) {
        $str3 = $consume;
    } elseif ($str == "") {

    }
    if (!$str && !$str1 && !$str2 && !$str3) {
        return 0;
    }
    $FFF = "";
    if ($str) {
        $FFF = $FFF. $str .  ":";
    }
    if($str1){
        $FFF = $FFF. $str1 . ":";
    }

    if($str2){
        $FFF = $FFF. $str2 . ":";
    }

    if($str3){
        $FFF = $FFF. $str3 ;
    }

    return $FFF;
}


    function admingm($gmdata)
{
    $url = "http://127.0.0.1:8877/gm";
    $data_user = \think\Db::name("gameconfig")->where("server", $gmdata["server"])->field("ip,gmport")->find();
    if (!$data_user["ip"]) {
        return "ip未设置";
    }
    $getdata = ["server" => $gmdata["server"], "cmd" => $gmdata["cmda"], "subcmd" => $gmdata["cmdb"], "body" => $gmdata["body"], "ip" => $data_user["ip"], "gmport" => $data_user["gmport"]];
    $Test = ["server", "cmd", "subcmd"];
    $Testyz = "#".getSign()."#";
    foreach ($Test as $x => $x_value) {
        if (isset($getdata[$x_value])) {
            $Testyz = $Testyz . $x_value . "*" . $getdata[$x_value];
        } else {
            $Testyz = $Testyz . $x_value . "*" . "";
        }
    }
    $Testyz = $Testyz . "#".getSign()."#";
    $getdata["md5"] = md5($Testyz);
    $getdata["body"] = json_encode($getdata["body"]);
    $returngm = http_curl($url, "get", $getdata);

    if ($returngm) {
        $returngm = json_decode($returngm, true);
        if (isset($returngm["code"])) {
            if (isset($returngm["msg"]["body"])) {
                if ($gmdata["cmdb"] == "userNums") {
                    return $returngm["msg"]["body"];
                } else {
                return ["code" => $returngm["code"], "msg" => "success"];
                }
            } else {
                return ["code" => $returngm["code"], "msg" => "服务器返回参数错误 body"];
            }
        } else {
            return ["code" => "1001", "msg" => "服务器返回参数错误"];
        }
    } else {
        return ["code" => "1001", "msg" => "服务器连接失败"];
    }
}

function getSign() {
    return 'QQ:5311210';
}
function login_key(){
    return "[+Q317743968]";
}	
function senderName() {
    return 'GM邮件';
}
function mw_rank_update_key(){
    return "wch123.com";
}
