<?php


namespace app\pay\controller;

class Notify extends \think\Controller
{
	public function index()
	{
        $out_trade_no = $_GET['out_trade_no'];
    	$trade_no = $_GET['trade_no'];
    	$trade_status = $_GET['trade_status'];
    	$name = $_GET['name'];
    	$amount = $_GET['money'];
    	$type = $_GET['type'];
    	$sign = $_GET['sign'];
    	
    	$parameter = array(
    		"pid" => pay_customerid(),
    		"trade_no"	=> $trade_no,
    		"out_trade_no" => $out_trade_no,
    		"type" => $type,
    		"name"	=> $name,
    		"money"	=> $amount,
    		"trade_status" => $trade_status
        );
        $parameter1 = argsSort($parameter);
        $signStr = createLinkstring($parameter1);
        $signServer = md5Sign($signStr, pay_userkey());
        
        if($signServer != $sign){
            echo "签名错误";
            exit;
        }
	    if ($trade_status != 'TRADE_SUCCESS') {
	        echo "支付状态错误";
            exit;
	    }
	    
	    $data = \think\Db::name("gamebuy_log")->field(true)->where("orderId", $out_trade_no)->find();
        if($data){
            if($data["status"] == 0){
                
                $this->agentPoint($data["agent"], $data["account"], \intval($amount), $out_trade_no, $trade_no);
                
                $this->sendItem($data);
                
                \think\Db::name("gamebuy_log")->where("orderId", $out_trade_no)->update(["status" => 1, "payId" => $trade_no, "payTime" => date("Y-m-d H:i:s", time())]);
                
                \think\Db::name("user")->where("account", $data["account"])->setInc("recharge", \intval($amount));
                
                echo "success";
                exit;
            }else{
                echo "订单已处理";
                exit;
            }
        }else{
            echo "订单不存在";
            exit;
        }
	}
	
	private function sendItem($orderInfo){
	    $productInfo = \think\Db::name("payconfig")->field(true)->where("id", $orderInfo["productId"])->find();
	    
	    $goods = $productInfo["goods"];
	    if($productInfo["firstAdd"] != ""){
	        $count = \think\Db::name("gamebuy_log")->where(["account" => $orderInfo["account"], "server" => $orderInfo["server"], "productId" => $orderInfo["productId"], "status" => 1])->count();
	        if ($count <= 1) {
	            $goods = $goods.";".$productInfo["firstAdd"];
	        }
	    }
	    
	    $gameInfo = \think\Db::name("gameconfig")->field(true)->where("server", $orderInfo["server"])->find();
	    
	    $this->realSendItems($orderInfo, $gameInfo, $goods);
	}
	
	private function realSendItems($orderInfo, $gameInfo, $goods){
	    $url = "http://127.0.0.1:8877/gm";
	    
	    $serverid = $orderInfo["server"];
	    $guid = $orderInfo["guid"];
			
		$getdata["server"] = $serverid;
		$getdata["guid"] = $guid;
		$getdata["cmd"] = "itemManage";
		$getdata["subcmd"] = "giveItem";
		$getdata["ip"] = $gameInfo["ip"];
		$getdata["gmport"] = $gameInfo["gmport"];
		$getdata["md5"] = md5("#0316-come.c#server*".$serverid."guid*".$guid."cmd*itemManage"."subcmd*giveItem"."#0725-come.c#");
	    
		$newarr = explode(";", $goods);
		
		$attach_item=[];
		for ($i = 0; $i < count($newarr); $i++) {
			$newarrd = explode(",", $newarr[$i]);
			if (isset($newarrd[0]) && isset($newarrd[1])) {
				$attach_item[] = ["id" => $newarrd[0], "num" => $newarrd[1]];
			}
		}
		
		$getdata["body"] = json_encode([
		    "player_list" => ["".$guid],
		    "server_broadcast" => "0",
		    "content" => "购买：".$orderInfo["productName"]."，价格：". $orderInfo["price"],
		    "items" => $attach_item
	        ]);
		$returngm = http_curl($url, "get", $getdata);
		
		if ($returngm) {
		    $returngm = json_decode($returngm, true);
		    if($returngm["code"] == 1000){
		        return true;
		    }
		}
        return false;
	}
	
	private function agentPoint($agent, $account, $money, $sdorderno, $sdpayno){
	    if(trim($agent) != ""){
	        $data = \think\Db::name("agent")->field(true)->where("account", $agent)->find();
    	    if($data){
    	        $branch = $data["branch"];
    	        $rmb = $money * ($branch / 100);
    	        
    	        \think\Db::name("agent")->where("account", $agent)->setInc("rmb", $rmb);
    	        
    	        $order_id = time().rand(1, 1000000);
    	        $insert["agent"] = $agent;
                $insert["order_id"] = $sdorderno;
                $insert["pay_id"] = $sdpayno;
                $insert["account"] = $account;
        		$insert["money"] = $money;
        		$insert["point"] = $rmb;
        		$insert["time"] = date("Y-m-d H:i:s", time());
        		\think\Db::name("agent_log")->data($insert)->insert();
        	
        		$this->agentPoint($data["agent"], $account, $money, $sdorderno, $sdpayno);
    	    }
	    }
	}
}