<?php


namespace app\pay\controller;

class Dopay extends \think\Controller
{
	public function index()
	{
	    if(isset($_GET['account']) && isset($_GET['serverid']) && isset($_GET['guid']) && isset($_GET['productId']) && isset($_GET['timestamp']) && isset($_GET['sign'])){
	        $account = $_GET['account'];
	        $serverid = $_GET['serverid'];
	        $guid = $_GET['guid'];
	        $productId = $_GET['productId'];
	        
	        $timestamp = $_GET['timestamp'];
	        $sign = $_GET['sign'];
	        
	        $signKey = "mwald-sign";
	        $signStr = $account."|".$serverid."|".$guid."|".$timestamp.$signKey;
	        $sign1 = md5($signStr);
	        if($sign1 != $sign){
	            return json(["ret" => 0, "msg" => "签名错误！"]);
	        }
	        
	        $data = \think\Db::name("payconfig")->field(true)->where("id", $productId)->find();
	        if(!$data){
	            return json(["ret" => -1, "msg" => "购买物品不存在"]);
	        }
	        
	        $data1 = \think\Db::name("user")->field(true)->where("account", $account)->find();
	        if(!$data1){
	            return json(["ret" => -1, "msg" => "充值账号不存在"]);
	        }
	        
	       // return "支付维护，充值暂不可用";
	        
	        $price = $data["price"];
	        
	        $order_id = time().rand(1, 100000);
            $insert["orderId"] = $order_id;
            $insert["account"] = $account;
            $insert["server"] = $serverid;
            $insert["guid"] = $guid;
            $insert["productId"] = $productId;
            $insert["productName"] = $data["name"];
    		$insert["agent"] = $data1["agent"];
    		$insert["price"] = $price;
    		$insert["channel"] = "Internal";
    		$insert["time"] = date("Y-m-d H:i:s", time());
    		$insert["status"] = 0;
    		\think\Db::name("gamebuy_log")->data($insert)->insert();
    		
    		
    // 		return $this->donKuraPay($order_id, $price, $account);
    		return $this->doShPay($order_id, $price);
	    }else{
	        return json(["ret" => -1, "msg" => "非法访问"]);
	    }
	}
	
	private function donKuraPay($order_id, $price, $account){
	    $notify_url = "http://mwhiald.zgspl.cn/pay/notify";
		$return_url = "http://mwhiald.zgspl.cn";
		$name = $account."-".$price;
		$amount = number_format($price,2,'.','')."";
		
		$payType = "alipay";
		$parameter = array(
    		"pid" => pay_customerid(),
    		"type" => $payType,
    		"out_trade_no" => $order_id,
    		"notify_url"	=> $notify_url,
    		"return_url"	=> $return_url,
    		"name"	=> $name,
    		"money"	=> $amount
        );
        
        $parameter1 = argsSort($parameter);
        $paySignStr = createLinkstring($parameter1);
        $paySign = md5Sign($paySignStr, pay_userkey());
        
        $this->assign("customerid", pay_customerid());
        $this->assign("type", $payType);
        $this->assign("order_id", $order_id);
        $this->assign("notify_url", $notify_url);
        $this->assign("return_url", $return_url);
        $this->assign("name", $name);
        $this->assign("money", $amount);
        $this->assign("sign", $paySign);
		return $this->fetch("gateway");
	}
	
	private function doShPay($order_id, $price){
        $amount = number_format($price,2,'.','')."";
		$signData = array('amount'=>$amount, 'out_trade_no'=>$order_id);
	    $sign = pay_sign(pay_userkey(), $signData);
	    
        $this->assign("customerid", pay_customerid());
        $this->assign("userkey", pay_userkey());
        $this->assign("sign", $sign);
        $this->assign("amount", $amount);
        $this->assign("order_id", $order_id);
		
		return $this->fetch("gateway-sh");
	}
	
}