<?php
namespace app\pay\controller;

class Home extends \think\Controller
{
	public function index() {
        $account=\think\Session::get("account");
		$datae = \think\Db::name("user")->field("Id,rmb,lock")->where("account", $account)->find();
		if ($datae["lock"] != 0) {
		    return "账号被锁定！";
		}
		$HH = pay_k("", true);
			$rate = \think\Db::name("charge_rate")->where('status',1)->find();
		if (empty($rate)) {
		    $this->assign(['rate'=>0]);
		}else{
		    $this->assign(['rate'=>$rate['rate']]);
		}
		$token = $this->request->token("__token__", "sha1");
			    $serverid=\think\Session::get("serverid");
	    $guid=\think\Session::get("guid");
		$this->assign(["token" => $token, "rmb" => $datae["rmb"], "HHHH" => $HH, "account" => $account,'server'=>$serverid,'guid'=>$guid]);
		$tokenss=$this->fetch();
		return $this->fetch();
	}

	public function pay(){
	    $account=\think\Session::get("account");
		$datae = \think\Db::name("user")->field("Id,rmb,lock")->where("account", $account)->find();
		if ($datae["lock"] != 0) {
		    return "账号被锁定！";
		}
		$HH = pay_kk("", true);
		$token = $this->request->token("__token__", "sha1");
		$this->assign(["token" => $token, "rmb" => $datae["rmb"], "HHHH" => $HH, "account" => $account]);
		return $this->fetch("pay");
	}
	
	public function doPay(){
	    $request = \think\Request::instance()->post();
	    $account=\think\Session::get("account");
	    $money=\intval($request["money"]);
	    $type=$request["type"];
	    $datae = \think\Db::name("user")->field("Id,agent,lock")->where("account", $account)->find();
	    if ($datae["lock"] != 0) {
		    return "账号被锁定！";
		}
	    $order_id = time().rand(1, 1000000);
		$Testdata["order_id"] = $order_id;
        $Testdata["account"] = $account;
		$Testdata["agent"] = $datae["agent"];
		$Testdata["money"] = $money;
		$Testdata["pay_type"] = $type;
		$Testdata["time"] = date("Y-m-d H:i:s", time());
		$Testdata["status"] = 0;
		\think\Db::name("charge_order")->data($Testdata)->insert();
		$notify_url = "http://192.168.200.88:81/pay/Home/payNotify";
		$return_url = "http://192.168.200.88:81/pay/Home";
		$parameter = array(
    		"pid" => pay_customerid(),
    		"type" => $type,
    		"out_trade_no" => $order_id,
    		"notify_url"	=> $notify_url,
    		"return_url"	=> $return_url,
    		"name"	=> $account,
    		"money"	=> $money
        );
        
        $parameter1 = argsSort($parameter);
        $paySignStr = createLinkstring($parameter1);
        $paySign = md5Sign($paySignStr, pay_userkey());
        
        $this->assign("customerid", pay_customerid());
        $this->assign("type", $type);
        $this->assign("order_id", $order_id);
        $this->assign("notify_url", $notify_url);
        $this->assign("return_url", $return_url);
        $this->assign("name", $account);
        $this->assign("money", $money);
        $this->assign("sign", $paySign);
		return $this->fetch("gateway");
		
		
	}
	
	public function payNotify(){
        $out_trade_no = $_GET['out_trade_no'];
    	$pay_no = $_GET['trade_no'];
    	$trade_status = $_GET['trade_status'];
    	$name = $_GET['name'];
    	$amount = $_GET['money'];
    	$type = $_GET['type'];
    	$sign = $_GET['sign'];
    	
    	$parameter = array(
    		"pid" => pay_customerid(),
    		"trade_no"	=> $pay_no,
    		"out_trade_no" => $out_trade_no,
    		"type" => $type,
    		"name"	=> $name,
    		"money"	=> $amount,
    		"trade_status" => $trade_status
        );
        $parameter1 = argsSort($parameter);
        $signStr = createLinkstring($parameter1);
        $signServer = md5Sign($signStr, pay_userkey());
        
        if($signServer != $sign){
            echo "签名错误";
            exit;
        }
	    if ($trade_status != 'TRADE_SUCCESS') {
	        echo "支付状态错误";
            exit;
	    }
	    
	    $datae = \think\Db::name("charge_order")->field("id,account,money,agent,status")->where("order_id", $out_trade_no)->find();
        if($datae){
            if($datae["status"] == 0){
                
                if($datae["money"] != intval($amount)){
                    echo "回调金额错误";
                    exit;
                }
                	$rate = \think\Db::name("charge_rate")->where('status',1)->find();
		            if (!empty($rate)) {
		            
		                //$amount = $rate['rate'] * $amount;
		            }
                \think\Db::name("charge_order")->where("order_id", $out_trade_no)->update(["status" => 1, "pay_id" => $pay_no, "pay_time" => date("Y-m-d H:i:s", time())]);
                $moneys = $amount * 1; //充值比例设置
                \think\Db::name("user")->where("account", $datae["account"])->setInc("rmb", \intval($moneys));
                
                $this->agentPoint($datae["agent"], $datae["account"], \intval($amount), $out_trade_no, $pay_no);
                echo "success";
                exit;
            }else{
                echo "订单已处理";
                exit;
            }
        }else{
            echo "订单不存在";
            exit;
        }
	}
	
	

	
	protected function agentPoint($agent, $account, $money, $sdorderno, $sdpayno){
		$datae = \think\Db::name("agent")->field("id,branch,agent")->where("account", $agent)->find();
		if($datae){
			$branch=$datae["branch"];
			$rmb=$money * ($branch / 100);
			\think\Db::name("agent")->where("account", $agent)->setInc("rmb", $rmb);
			
			$order_id = time().rand(1, 1000000);
			$Testdata["agent"] = $agent;
			$Testdata["order_id"] = $sdorderno;
			$Testdata["pay_id"] = $sdpayno;
			$Testdata["account"] = $account;
			$Testdata["money"] = $money;
			$Testdata["point"] = $rmb;
			$Testdata["time"] = date("Y-m-d H:i:s", time());
			\think\Db::name("agent_log")->data($Testdata)->insert();
		
			$this->agentPoint($datae["agent"], $account, $money, $sdorderno, $sdpayno);
		}


	}

}